//+------------------------------------------------------------------+
//|                                                      Ma Line.mq4 |
//|                                                      T.Indicator |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, "
#property link      "T.Indicator"

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1 SteelBlue
#property indicator_color2 Orange
#property indicator_color3 Black
#property indicator_color4 Blue
#property indicator_color5 Red

double G_ibuf_76[];
double G_ibuf_80[];
double G_ibuf_84[];
double G_ibuf_88[];
double G_ibuf_92[];

extern int period = 10;
extern int price = 0;
extern bool Mode_Fast = FALSE;
extern bool Signals = FALSE;
extern int MA1period = 9;
extern int MA2period = 45;
extern string TypeHelp = "SMA- 0, EMA - 1, SMMA - 2, LWMA- 3";
extern string TypeHelp2 = "John Hyden settings TypeMA1=0, TypeMA2=3";
extern int TypeMA1 = 0;
extern int TypeMA2 = 3;

double Gd_144 = 0.0;
double Gd_152 = 0.0;
double Gd_unused_160 = 0.0;
double Gd_168 = 0.0;
double Gd_176 = 0.0;
double Gd_184 = 0.0;
int Gi_unused_192 = 0;
int Gi_unused_196 = 0;


int init() {
   SetIndexStyle(0, DRAW_NONE, STYLE_SOLID, 1, SteelBlue);
   SetIndexBuffer(0, G_ibuf_76);
   
   SetIndexStyle(1, DRAW_NONE, STYLE_SOLID, 1, Orange);
   SetIndexBuffer(1, G_ibuf_80);
   
   SetIndexStyle(2, DRAW_NONE);
   SetIndexLabel(2, "line");
   
   SetIndexBuffer(2, G_ibuf_84);
   
   SetIndexStyle(3, DRAW_LINE);
   SetIndexLabel(3, "MA1 " + MA1period);
   
   SetIndexStyle(4, DRAW_LINE);
   SetIndexLabel(4, "MA2 " + MA2period);
   
   SetIndexBuffer(3, G_ibuf_88);
   SetIndexBuffer(4, G_ibuf_92);
   
   return (0);
}


int deinit() {
   for (int count_0 = 0; count_0 < Bars; count_0++) {
      ObjectDelete("SELL SIGNAL: " + DoubleToStr(count_0, 0));
      ObjectDelete("BUY SIGNAL: " + DoubleToStr(count_0, 0));
      ObjectDelete("EXIT: " + DoubleToStr(count_0, 0));
   }
   return (0);
}


//+======================================================================================+
//+================================ www.expforex.com edit AlertArrow ====================+
//+======================================================================================+
  extern string Alerts="    www.expforex.com";
  extern bool AlerT=true;  //              
  extern bool Mail=true;   //           
  extern bool Push=true;   //    
  extern bool Arrow=true;  //    
  extern int shift=1;      //      0 -   1 -  
  int timeee;              //  
  string nameInd;
 
void SetArrow(int cd, color cl,
              string nm="", datetime t1=0, double p1=0, int sz=3) {
  if (nm=="") nm=DoubleToStr(Time[0], 0);
  if (t1<=0) t1=Time[0];
  if (p1<=0) p1=Bid;
  nameInd=WindowExpertName( );
int wind=WindowFind(nameInd);
if (wind==-1)wind=0;
  if (ObjectFind(nm)<0) ObjectCreate(nm, OBJ_ARROW, wind, 0,0);
  ObjectSet(nm, OBJPROP_TIME1    , t1);
  ObjectSet(nm, OBJPROP_PRICE1   , p1);
  ObjectSet(nm, OBJPROP_ARROWCODE, cd);
  ObjectSet(nm, OBJPROP_COLOR    , cl);
  ObjectSet(nm, OBJPROP_WIDTH    , sz);
}
 
void Expforex_AlertArrow(string text="",int arrowdir=0)
{
nameInd=WindowExpertName( );
int wind=WindowFind(nameInd);
if (wind==-1)wind=0;
   ObjectCreate("Originalalert",OBJ_LABEL,wind,0,0);
   ObjectSetText("Originalalert"," AlertArrow www.expforex.com",10,"Arial Bold",Red);
   ObjectSet("Originalalert",OBJPROP_CORNER,2);
   ObjectSet("Originalalert",OBJPROP_XDISTANCE,200);
   ObjectSet("Originalalert",OBJPROP_YDISTANCE,10);
   
                if(AlerT) Alert(text);
                if(Arrow) if (arrowdir==1) SetArrow(241,Blue,nameInd+DoubleToStr(Time[shift],0),Time[shift],Low[shift]);
                if(Arrow) if (arrowdir==2) SetArrow(242,Red,nameInd+DoubleToStr(Time[shift],0),Time[shift],High[shift]);
                if (!IsTesting())if(Mail)  SendMail(text, text);
                if (!IsTesting())if(Push)  SendNotification(text);
 
}
 
//+======================================================================================+
//+================================ www.expforex.com edit AlertArrow ====================+
//+======================================================================================+
int start() {
   double price_12;
   double Ld_unused_20;
   int Li_0 = IndicatorCounted();
   double low_28 = 0;
   double high_36 = 0;
   double Ld_44 = 1.2;
   if (Li_0 > 0) Li_0--;
   int Li_8 = Bars - Li_0;
   if (Mode_Fast) Li_8 = 100;
   for (int Li_4 = 0; Li_4 < Li_8; Li_4++) {
      high_36 = High[iHighest(NULL, 0, MODE_HIGH, period, Li_4)];
      low_28 = Low[iLowest(NULL, 0, MODE_LOW, period, Li_4)];
      switch (price) {
      case 1:
         price_12 = Open[Li_4];
         break;
      case 2:
         price_12 = Close[Li_4];
         break;
      case 3:
         price_12 = High[Li_4];
         break;
      case 4:
         price_12 = Low[Li_4];
         break;
      case 5:
         price_12 = (High[Li_4] + Low[Li_4] + Close[Li_4]) / 3.0;
         break;
      case 6:
         price_12 = (Open[Li_4] + High[Li_4] + Low[Li_4] + Close[Li_4]) / 4.0;
         break;
      case 7:
         price_12 = (Open[Li_4] + Close[Li_4]) / 2.0;
         break;
      default:
         price_12 = (High[Li_4] + Low[Li_4]) / 2.0;
      }
      Gd_144 = 0.66 * ((price_12 - low_28) / (high_36 - low_28) - 0.5) + 0.67 * Gd_152;
      Gd_144 = MathMin(MathMax(Gd_144, -0.999), 0.999);
      Gd_168 = MathLog((Gd_144 + 1.0) / (1 - Gd_144)) / 2.0 + Gd_176 / 2.0;
      G_ibuf_76[Li_4] = 0;
      G_ibuf_80[Li_4] = 0;
      if (Gd_168 < 0.0 && Gd_176 > 0.0) {
         if (Signals) {
            ObjectCreate("EXIT: " + DoubleToStr(Li_4, 0), OBJ_TEXT, 0, Time[Li_4], price_12);
            ObjectSetText("EXIT: " + DoubleToStr(Li_4, 0), "EXIT AT " + DoubleToStr(price_12, 4), 7, "Arial", White);
         }
         Gi_unused_192 = 0;
      }
      if (Gd_168 > 0.0 && Gd_176 < 0.0) {
         if (Signals) {
            ObjectCreate("EXIT: " + DoubleToStr(Li_4, 0), OBJ_TEXT, 0, Time[Li_4], price_12);
            ObjectSetText("EXIT: " + DoubleToStr(Li_4, 0), "EXIT AT " + DoubleToStr(price_12, 4), 7, "Arial", White);
         }
         Gi_unused_196 = 0;
      }
      if (Gd_168 >= 0.0) {
         G_ibuf_76[Li_4] = Gd_168;
         G_ibuf_84[Li_4] = Gd_168;
      } else {
         G_ibuf_80[Li_4] = Gd_168;
         G_ibuf_84[Li_4] = Gd_168;
      }
      Ld_unused_20 = Li_4;
      if (Gd_168 < (-Ld_44) && Gd_168 > Gd_176 && Gd_176 <= Gd_184) {
         if (Signals) {
            ObjectCreate("SELL SIGNAL: " + DoubleToStr(Li_4, 0), OBJ_TEXT, 0, Time[Li_4], price_12);
            ObjectSetText("SELL SIGNAL: " + DoubleToStr(Li_4, 0), "SELL AT " + DoubleToStr(price_12, 4), 7, "Arial", Red);
         }
         Gi_unused_196 = 1;
      }
      if (Gd_168 > Ld_44 && Gd_168 < Gd_176 && Gd_176 >= Gd_184) {
         if (Signals) {
            ObjectCreate("BUY SIGNAL: " + DoubleToStr(Li_4, 0), OBJ_TEXT, 0, Time[Li_4], price_12);
            ObjectSetText("BUY SIGNAL: " + DoubleToStr(Li_4, 0), "BUY AT " + DoubleToStr(price_12, 4), 7, "Arial", Lime);
         }
         Gi_unused_192 = 1;
      }
      Gd_152 = Gd_144;
      Gd_184 = Gd_176;
      Gd_176 = Gd_168;
   }
   for (Li_4 = 0; Li_4 < Li_8; Li_4++) G_ibuf_88[Li_4] = iMAOnArray(G_ibuf_84, Bars, MA1period, 0, TypeMA1, Li_4);
   for (Li_4 = 0; Li_4 < Li_8; Li_4++) G_ibuf_92[Li_4] = iMAOnArray(G_ibuf_88, Bars, MA2period, 0, TypeMA2, Li_4);
   //+======================================================================================+
//+================================ www.expforex.com edit AlertArrow ====================+
//+======================================================================================+
 nameInd=WindowExpertName( );
          if (Gd_168 < (-Ld_44) && Gd_168 > Gd_176 && Gd_176 <= Gd_184) 
          if (Gd_168 < 0.0 && Gd_176 > 0.0) {
          
                 Expforex_AlertArrow(Symbol()+" "+Period()+nameInd+" UP",1);
                    timeee=Time[0];           
               }
 
           if (Gd_168 > Ld_44 && Gd_168 < Gd_176 && Gd_176 >= Gd_184) 
           if (Gd_168 > 0.0 && Gd_176 < 0.0) {
           
                 Expforex_AlertArrow(Symbol()+" "+Period()+nameInd+" DN",2);
                    timeee=Time[0];           
               }
//+======================================================================================+
//+================================ www.expforex.com edit AlertArrow ====================+
//+======================================================================================+
   return (0);
}